gtkmm: Gtk::SelectionFilterModel Class Reference

gtkmm 4.13.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::SelectionFilterModel Class Reference
ListView Classes

A list model that turns a selection in a model. More...

`#include <gtkmm/selectionfiltermodel.h>`

Inheritance diagram for Gtk::SelectionFilterModel:
[legend]

## Public Member Functions
| SelectionFilterModel (SelectionFilterModel && src) noexcept
SelectionFilterModel & | operator= (SelectionFilterModel && src) noexcept
| ~SelectionFilterModel () noexcept override
GtkSelectionFilterModel * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkSelectionFilterModel * | gobj () const
| Provides access to the underlying C GObject. More...
GtkSelectionFilterModel * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_model (const Glib::RefPtr< SelectionModel > & model)
| Sets the model to be filtered. More...
Glib::RefPtr< SelectionModel > | get_model ()
| Gets the model currently filtered or `nullptr` if none. More...
Glib::RefPtr< const SelectionModel > | get_model () const
| Gets the model currently filtered or `nullptr` if none. More...
Glib::PropertyProxy_ReadOnly< GType > | property_item_type () const
| The type of items. More...
Glib::PropertyProxy< Glib::RefPtr< SelectionModel > > | property_model ()
| The model being filtered. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< SelectionModel > > | property_model () const
| The model being filtered. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_items () const
| The number of items. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::RefPtr< T_item > | get_typed_object (guint position)
Glib::RefPtr< const T_item > | get_typed_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SelectionFilterModel > | create (const Glib::RefPtr< SelectionModel > & model)
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
| SelectionFilterModel (const Glib::RefPtr< SelectionModel > & model)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::SelectionFilterModel > | wrap (GtkSelectionFilterModel * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A list model that turns a selection in a model.

Gtk::SelectionFilterModel is a list model that presents the selected items in a Gtk::SelectionModel as its own list model.

See also
  Gtk::SelectionModel

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ SelectionFilterModel() [1/2]

Gtk::SelectionFilterModel::SelectionFilterModel | ( | SelectionFilterModel && | src | ) |
| noexcept

## ◆ ~SelectionFilterModel()

Gtk::SelectionFilterModel::~SelectionFilterModel | ( |  | ) |
| overridenoexcept

## ◆ SelectionFilterModel() [2/2]

Gtk::SelectionFilterModel::SelectionFilterModel | ( | const Glib::RefPtr< SelectionModel > & | model | ) |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< SelectionFilterModel > Gtk::SelectionFilterModel::create | ( | const Glib::RefPtr< SelectionModel > & | model | ) |
| static

## ◆ get_model() [1/2]

Glib::RefPtr< SelectionModel > Gtk::SelectionFilterModel::get_model | ( |  | ) |

Gets the model currently filtered or `nullptr` if none.

Returns
  The model that gets filtered.

## ◆ get_model() [2/2]

Glib::RefPtr< const SelectionModel > Gtk::SelectionFilterModel::get_model | ( |  | ) | const

Gets the model currently filtered or `nullptr` if none.

Returns
  The model that gets filtered.

## ◆ get_type()

static GType Gtk::SelectionFilterModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkSelectionFilterModel * Gtk::SelectionFilterModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSelectionFilterModel * Gtk::SelectionFilterModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkSelectionFilterModel * Gtk::SelectionFilterModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SelectionFilterModel & Gtk::SelectionFilterModel::operator= | ( | SelectionFilterModel && | src | ) |
| noexcept

## ◆ property_item_type()

Glib::PropertyProxy_ReadOnly< GType > Gtk::SelectionFilterModel::property_item_type | ( |  | ) | const

The type of items.

See Gio::ListModel::get_item_type().

Since gtkmm 4.8:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< SelectionModel > > Gtk::SelectionFilterModel::property_model | ( |  | ) |

The model being filtered.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< SelectionModel > > Gtk::SelectionFilterModel::property_model | ( |  | ) | const

The model being filtered.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_n_items()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::SelectionFilterModel::property_n_items | ( |  | ) | const

The number of items.

See Gio::ListModel::get_n_items().

Since gtkmm 4.8:

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_model()

void Gtk::SelectionFilterModel::set_model | ( | const Glib::RefPtr< SelectionModel > & | model | ) |

Sets the model to be filtered.

Note that GTK makes no effort to ensure that model conforms to the item type of self. It assumes that the caller knows what they are doing and have set up an appropriate filter to ensure that item types match.

Parameters

  model | The model to be filtered.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::SelectionFilterModel > wrap | ( | GtkSelectionFilterModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.